Want to contribute? Great! First, read this page (including the small print at the end).

## Before you contribute

Before we can use your code, you must sign the
[Google Individual Contributor License Agreement](https://developers.google.com/open-source/cla/individual?csw=1)
(CLA), which you can do online. The CLA is necessary mainly because you own the
copyright to your changes, even after your contribution becomes part of our
codebase, so we need your permission to use and distribute your code. We also
need to be sure of various other things -- for instance that you'll tell us if
you know that your code infringes on other people's patents. You don't have to
sign the CLA until after you've submitted your code for review and a member has
approved it, but you must do it before we can put your code into our codebase.

Before you start working on a larger contribution, you should get in touch with
us first through the issue tracker with your idea so that we can help out and
possibly guide you. Coordinating up front makes it much easier to avoid
frustration later on.

## Coding style

For our C++ files, we use the
[Google C++ style guide](http://google-styleguide.googlecode.com/svn/trunk/cppguide.html).
(Conveniently, the formatting rules it specifies can be achieved using
`clang-format -style=google`.)

For our Python files, we use the
[Google Python style guide](https://google-styleguide.googlecode.com/svn/trunk/pyguide.html).

## Bug tracking

We use GitHub's issue-tracker mechanism for submitting and resolving bugs in
Shaderc.

## Code reviews

All submissions, including submissions by project members, require review. We
use GitHub pull requests for this purpose.

A pull request may be accepted by any one of the package maintainers.  You
should expect the maintainers to strictly insist on the
[commenting](http://google-styleguide.googlecode.com/svn/trunk/cppguide.html#Comments)
guidelines -- in particular, every file, class, method, data member, and global
will require a comment.  The maintainers will also expect to see test coverage
for every code change.  _How much_ coverage will be a judgment call on a
case-by-case basis, balancing the required effort against the incremental
benefit.  But coverage will be expected.  As a matter of development philosophy,
we will strive to engineer the code to make writing tests easy.

## Supported platforms

We expect Shaderc to always build and test successfully on the platforms listed
below.  Please keep that in mind when offering contributions.  This list will
likely grow over time.

* Linux x86

## The small print

Contributions made by corporations are covered by a different agreement than
the one above, the Software Grant and Corporate Contributor License Agreement.
